//-------------------------------------------------------------------//
//                                                                   //
//  JFC Copyright (C) Glenn Rosenthal, 1999,2000,2001.               //
//  All rights reserved.                                             //
//                                                                   //   
//  These routines are intended to interface with EDICT, which is    //
//  a Japanese/English Dictionary developed and copyrighted by       //
//  James William Breen.                                             //
//                                                                   //   
//-------------------------------------------------------------------//

//-------------------------------------------------------------------
//
//  This module implements the dictionary search and mantinance routines.
//  These handle all interactions with the dictionaries and with searching.
//

#ifndef jfc_dict_h
#define jfc_dict_h

                                    // Error conditions for dictionary search.  These indicate valid search arguments.
#define DICTSEARCH_OKAY     0       // Search string is OK.
#define DICTSEARCH_SHORT    1       // Search string is too short.
#define DICTSEARCH_MIXED    2       // Search string contains mixed ascii and Japanese.
#define DICTSEARCH_ABORT    10      // User aborted the search!

class JFC_dict {
public:
  int  search_dict    (KANJI *search_ptr,KANJI *result);        // Actually search.
private:
  void check_entry    (byte *data,int length);                  // Check an entry for includsion
  int  do_search      (KANJI *search,int length);               // Actually executat a search for a specific pattern, seith a set of parameters.
  void format_line    (byte *data);                             // Format output line.
  void get_line       (HANDLE index,HANDLE dict,int loc,byte *buffer);  // Get a line from the dictionary file.
  void search_index   (byte *key,int length,TCHAR *name);       // Search indexed dictionary.
  void search_memory  (byte *key,int length,byte *dict);        // Search memory dictionary.

  short     matches;            // Number of valid matches.
  KANJI    *output;             // Results array.
};

typedef class JFC_dict JFC_dict;

extern void free_dictionary (void); // Deallocate dictionary objects.

#endif jfc_dict_h

