//-------------------------------------------------------------------//
//                                                                   //
//  JFC Copyright (C) Glenn Rosenthal, 1999,2000,2001.               //
//  All rights reserved.                                             //
//                                                                   //
//-------------------------------------------------------------------//

#include "jfc_main.h"
#include "jfc_conf.h"
#include "jfc_help.h"

//
//  Process help based on ID number.  Id numbers come from Windows 95
//  type help.  For Windows CE they are converted in URL's and sent
//  to Pocket Internet Exporer for processing.
//
//      hwnd -- Window that called help, so system cant return to 
//              this window.
//      id   -- Help ID to find.  An ID of zero will bring the 
//              help contents.
//
//  Due to a bug in Pocket Internet Explorer (2.0 SP 1), full URL's 
//  are not accepted, thus help can only get you to the correct 
//  chapter of help, and not to the actual section.  The part of the 
//  URL after # is not processed by PIE.
//
#define SIZE_HELP   (sizeof(help)/sizeof(struct helpinfo))  // Number of help ID used in Windows CE.

void do_help (HWND hwnd,int id) {
#ifdef WINCE
  struct helpinfo {     // Used to translate ID to URL.
    ushort id;          // ID number
    TCHAR *file;        // Main part of file name "m_<file>.html"
    TCHAR *section;     // Section within the file "#<section>".  (NULL = top of file.)
  };
  static struct helpinfo help[] = {
    { IDH_INTERFACE_COLOR ,TEXT("interface"),TEXT("COLOR")    },
    { IDH_INSTALL_ADVANCED,TEXT("install")  ,TEXT("MORE")     },
    { IDH_INSTALL_MORE    ,TEXT("install")  ,TEXT("MORE")     },
    { IDH_OPTIONS_ADVANCED,TEXT("opts")     ,TEXT("ADVANCED") },
    { IDH_OPTIONS_FONT    ,TEXT("opts")     ,TEXT("FONT")     },
    { IDH_OPTIONS_GENERAL ,TEXT("opts")     ,TEXT("GENERAL")  },
    { IDH_OPTIONS_INTRO   ,TEXT("opts")     ,NULL             },
    { IDH_OPTIONS_KANJI   ,TEXT("opts")     ,TEXT("KANJI")    },
    { IDH_OPTIONS_REVIEW  ,TEXT("opts")     ,TEXT("REVIEW")   },
    { IDH_OPTIONS_VOCAB   ,TEXT("opts")     ,TEXT("VOCAB")    },
  };
  int i;
  TCHAR buffer[SIZE_BUFFER];
  for (i = 0; (i < SIZE_HELP) && (help[i].id != id); i++);  // Find ID
  if (i == SIZE_HELP) id = 0;                               // Not found, use ID 0.
  if (!id) {                                                // ID zero, just go to contents.
    lstrcpy (buffer,TEXT("jfc-help\\fm_main.html"));
  }
  else {                                                    // Actual ID so build URL.
    lstrcpy (buffer,TEXT("jfc-help\\f_"));        
    lstrcat (buffer,help[i].file);
    lstrcat (buffer,TEXT(".html"));
    if (help[i].section) {
      lstrcat (buffer,TEXT("#"));
      lstrcat (buffer,help[i].section);
    }
  }
  CreateProcess (TEXT("iexplore"),jfc_config.name(buffer),NULL,NULL,0,0,NULL,NULL,NULL,NULL);
#else
  WinHelp (hwnd,jfc_config.name(TEXT("JFC.hlp")),id ? HELP_CONTEXT : HELP_FINDER,id);
#endif WINCE
  return;
}

