//-------------------------------------------------------------------//
//                                                                   //
//  JFC Copyright (C) Glenn Rosenthal, 1999,2000,2001.               //
//  All rights reserved.                                             //
//                                                                   //
//-------------------------------------------------------------------//

#include <windows.h>

#ifndef jfc_main_h
#define jfc_main_h

#include "jfc_wnce.h"                           // Windows CE stuff
#include "resource.h"                           // Get the resource parameters for everyone
#ifndef WINCE
  #include <stdio.h>                            // Definition of sscanf() is here, but CE does not have this file
#endif


#define SIZE_BUFFER     512                             // Size of general working character buffer.
                                                        // Version special is defined in options and includes special flags.
#define VERSION_STRING  TEXT("1.20")                    // Version ID number
#define VERSION_NAME    TEXT("JFC ") VERSION_STRING     // Version name.

                                // Windows globals.
extern HWND      main_window;   // Main window (parent).
extern HINSTANCE instance;      // Our instance.
extern HINSTANCE language;      // Our language interface instance
extern HMENU     hmenu;         // Our menu.

typedef short           INT16;  // Various sizes (mostly used in relation to JWP structures).
typedef unsigned short  UINT16;
typedef UINT16          KANJI;
typedef unsigned short  ushort;
typedef unsigned long   ulong;

#define null            0       // Used to set handles to zero, clarifies memory refferences.

//
//  Custom window message values.
//
#define WMU_SETWINDOWVALUE  (WM_USER+1)     // Used to set control value for all working windows.
#define WMU_GETWINDOWVALUE  (WM_USER+2)     // Used to get structrues behind windows controls.
#define WMU_RESETLIST       (WM_USER+3)     // Reset a Japanese List control

//
//  Timer codes used by various timers.
//
#define TIME_SHOW   1                       // Timer for show message.
#define TIME_NEXT   2                       // Timer for next card.
#define TIME_KEY    3                       // Timer for keyboard double clicks.

#endif jfc_main_h

