//-------------------------------------------------------------------//
//                                                                   //
//  JFC Copyright (C) Glenn Rosenthal, 1999,2000,2001.               //
//  All rights reserved.                                             //
//                                                                   //
//-------------------------------------------------------------------//

//-------------------------------------------------------------------
//
//  This modlue is a collection of micelaeous routines not placed 
//  in any other module.
//
#ifndef jfc_misc_h
#define jfc_misc_h

//
//  File service routines.  These make using the CreateFile() rotuine easier, by 
//  supplying the general values for most of the arguments.
//
#define OPENREAD(f)     CreateFile (f,GENERIC_READ ,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL)
#define OPENWRITE(f)    CreateFile (f,GENERIC_WRITE,0,NULL,OPEN_ALWAYS  ,FILE_ATTRIBUTE_NORMAL,NULL)

//
//  String table manipulation tools.
//
#define GET_STRING(b,id)        LoadString(language,id,b,(sizeof(b)/sizeof(TCHAR)))
#define LOAD_STRING(b,id,s)     LoadString(language,id,b,s)

extern TCHAR *get_string    (int id);                   // Get string and return in a pointer to a static buffer.
extern TCHAR *format_string (TCHAR *buffer,int id,...); // Foramt a string based on an
extern TCHAR *zero_string   (TCHAR *buffer,int id);     // Get a string and convert tabs into zeros.

//
//  Error & Message Rotuines..
//
extern int  ButtonDialog (int idd,TCHAR *data,int help);                    // Processes a general button dialog.
extern void ErrorMessage (int error,int format,...);                        // General Error Message.
extern HWND JCreateDialog(int id,HWND hwnd,DLGPROC proc,long param=0);      // Version of system routine to generate a non-modal dialog
extern int  JDialogBox   (int id,HWND hwnd,DLGPROC proc,long param=0);      // Version of system routien to generate a dialog box.
extern int  JMessageBox  (HWND hwnd,int text,int caption,UINT type,...);    // Extened version of system message routine.
extern void OutOfMemory  (void);                                            // Out of Memory error.
extern int  YesNo        (int format,...);                                  // Put up a simple yes-no dialog box.

//
//  Dialog box Routines.
//
extern int  get_int     (HWND hwnd,int id,int min_val,int max_val,int def);   // Get int value from edit control.

//
//  File name routines.
//
extern int    FileExists (TCHAR *name);                 // Check to see if a file exists

//
//  Random number routines.
//
extern int  random       (int max);                     // Generate a random number from 0 to max.

//
//  Window/Menu control routines.
//
extern long   get_menudata (HMENU menu,int item,int position,TCHAR *buffer);    // Get information from recent files menu
extern TCHAR *get_folder   (int id,TCHAR *buffer);                              // Get a system folder.

//
//  Tab dialog box controller
//
//
//  Tab dialog box controler
//
#define WM_GETDLGVALUES (WM_USER+1) // Message sent to pages to read values out.

typedef struct TabPage {            // Defines a page of a Tab Dialog box.
  short   text;                     // Label for page.
  int     id;                       // ID of page template.
  DLGPROC procedure;                // Procedure for this page.
  ushort  help;                     // Help id
} TabPage;

typedef struct TabSetup {           // Defines a tab dialog box.
  TabPage *pages;                   // Pointer to array of TabPage structures.
  short    count;                   // Number of pages in the above array.
  short    page;                    // Current page.
  DLGPROC  procedure;               // Dialog proc for user buttons on the main page.
} TabSetup;

extern int TabDialog (int id,TabSetup *setup);

//
//  Kanji string manipulation functions
//
extern KANJI *kdupstr (KANJI *string);              // Duplicate a knaji string.    
extern void   kstrcpy (KANJI *dest,KANJI *source);  // Copy a string
extern int    kstrlen (KANJI *string);              // Get string length.


//
//  Graphics IO routins.
//
//      Fills a rectangle with the current background color.
//      This used to be done with direct calls to FillRect,
//      with color arguments, however, Windows CE does not 
//      correctly support these calls, thus I replaced the 
//      calls with this routine.
//
#ifdef WINCE 
  #define BackFillRect(hdc,rect)    FillRect (hdc,rect,GetStockObject(WHITE_BRUSH));
#else
  #define BackFillRect(hdc,rect)    FillRect (hdc,rect,(HBRUSH) (COLOR_WINDOW+1));
#endif WINCE

#endif jfc_misc_h



